\version "2.20.0"

#(define (make-dynamic-extra dynamic string)
 (let ((dtext (markup #:whiteout #:line (dynamic #:hspace 0.0 #:normal-text #:italic string)))
       (dvol  (assoc-ref absolute-volume-alist dynamic)))
     (set! absolute-volume-alist (assoc-set! absolute-volume-alist dtext dvol))
     (make-music
       'AbsoluteDynamicEvent
       'tweaks
         ;; calculate centering for text
;        (list (cons (quote X-offset) (+ -0.5 (* -0.5 (string-length dynamic)))))
         (list (cons 'X-offset (- 0.6 (/ (string-length dynamic) 2))))
       'text dtext)))

#(define (make-extra-dynamic dynamic string)
 (let ((dtext (markup #:whiteout #:line (#:normal-text #:italic string #:hspace 0.0 dynamic)))
       (dvol  (assoc-ref absolute-volume-alist dynamic)))
     (set! absolute-volume-alist (assoc-set! absolute-volume-alist dtext dvol))
     (make-music
       'AbsoluteDynamicEvent
       'tweaks
         ;; calculate centering for text
         (list (cons 'X-offset (- (string-length string))))
       'text dtext)))

piup      = #(make-extra-dynamic "p" "più")
pocof     = #(make-extra-dynamic "f" "poco")
semprep   = #(make-extra-dynamic "p" "sempre")

farco     = #(make-dynamic-extra "f" "arco")
parco     = #(make-dynamic-extra "p" "arco")
pdolce    = #(make-dynamic-extra "p" "e dolce")
pstaccato = #(make-dynamic-extra "p" "staccato")

fsfz      = #(make-dynamic-script "f sfz")
psfz      = #(make-dynamic-script "p sfz")

calandotext = \markup \normal-text \italic "calando"
calando = \tweak DynamicText.self-alignment-X #-0.8 #(make-dynamic-script calandotext)

#(begin
  (define now -inf.0)
  (define directions (format #f "~3,'0d.directions" N))
  (if (access? directions F_OK) (delete-file directions)))

Print_directions =
#(lambda (context)
  (make-engraver
    ((initialize translator)
      (if (not final)
        (begin
          (set-current-output-port (open-file directions "a"))
          (set! now -inf.0))))
    ((finalize translator)
      (if (not final)
        (begin
          (format #t "~%")
          (force-output))))

    (listeners
      ((articulation-event engraver event)
        (if (not final)
          (let* ((moment       (ly:moment-main (ly:context-now context)))
                 (articulation (format #f "~a" (ly:event-property event 'articulation-type)))
                 (parent       (ly:context-property-where-defined context 'currentBarNumber))
                 (bar          (ly:context-property parent 'currentBarNumber))
                 (position     (ly:moment-main (ly:context-property parent 'measurePosition))))
           (if (> moment now) (begin (set! now moment) (format #t "~%~5@a~6@a" bar position)))
           (format #t "~10@a" (substring articulation 0 (min (string-length articulation) 9))))))
      ((absolute-dynamic-event engraver event)
        (if (not final)
          (let* ((moment   (ly:moment-main (ly:context-now context)))
                 (dyntext  (format #f "~a" (ly:event-property event 'text)))
                 (parent   (ly:context-property-where-defined context 'currentBarNumber))
                 (bar      (ly:context-property parent 'currentBarNumber))
                 (position (ly:moment-main (ly:context-property parent 'measurePosition))))
           (if (> moment now) (begin (set! now moment) (format #t "~%~5@a~6@a" bar position)))
           (format #t "~10@a" (substring dyntext 0 (min (string-length dyntext) 9))))))
      ((crescendo-event engraver event)
        (if (not final)
          (let* ((moment   (ly:moment-main (ly:context-now context)))
                 (dyntext  (format #f "~a" (ly:event-property event 'text)))
                 (parent   (ly:context-property-where-defined context 'currentBarNumber))
                 (bar      (ly:context-property parent 'currentBarNumber))
                 (position (ly:moment-main (ly:context-property parent 'measurePosition))))
           (if (> moment now) (begin (set! now moment) (format #t "~%~5@a~6@a" bar position)))
           (format #t "~10@a" "cresc"))))
      ((decrescendo-event engraver event)
        (if (not final)
          (let* ((moment   (ly:moment-main (ly:context-now context)))
                 (dyntext  (format #f "~a" (ly:event-property event 'text)))
                 (parent   (ly:context-property-where-defined context 'currentBarNumber))
                 (bar      (ly:context-property parent 'currentBarNumber))
                 (position (ly:moment-main (ly:context-property parent 'measurePosition))))
           (if (> moment now) (begin (set! now moment) (format #t "~%~5@a~6@a" bar position)))
           (format #t "~10@a" "decresc"))))
    )))
