\version "2.20.0"

maxsystems = #(define-void-function (n) (integer?)
  (if final
    (ly:output-def-set-variable! (ly:book-paper $current-bookpart) 'max-systems-per-page n)
    (ly:output-def-set-variable! (ly:book-paper $current-bookpart) 'page-spacing-weight 0)))

#(define (mdashodd layout props arg)
  (if (chain-assoc-get 'header:nickname props)
    (interpret-markup layout props arg)
    empty-stencil))

#(define (mdasheven layout props arg)
  (if (chain-assoc-get 'header:variant props)
    (interpret-markup layout props arg)
    empty-stencil))

#(define (composed layout props arg)
  (define c (chain-assoc-get 'header:composed props))
  (if c
    (interpret-markup layout props (markup (#:concat ("(" c ")"))))
    empty-stencil))

\paper {
  staffspace = #(ly:output-def-lookup $defaultpaper 'staff-space)
  left-margin = #(* 12 staffspace)
  ragged-last-bottom = ##f

  bookTitleMarkup = \markup {
    \override #'(baseline-skip . 4.5)
    \column {
      \fill-line { \fromproperty #'header:dedication }
      \override #'(baseline-skip . 3.5)
      \column {
        \fill-line { \huge \larger \larger \bold \fromproperty #'header:title }
        \fill-line { \large \bold \fromproperty #'header:subsubtitle }
        \vspace #0.5
        \fill-line { \huge \larger \fromproperty #'header:subtitle }
      }
      \override #'(baseline-skip . 3.0)
      \column {
        \fill-line { \null \fromproperty #'header:composer }
        \fill-line { \null \line { \fromproperty #'header:opus \on-the-fly \composed \null } }
      }
    }
  }
  scoreTitleMarkup = \markup {
    \column {
      \fill-line { \null \huge \bold \fromproperty #'header:piece \null }
      \null
    }
  }

  oddHeaderMarkup = \markup \column {
    \fill-line {
      \null
      \on-the-fly #not-part-first-page \normalsize \line { "Symphony Nº" #(number->string N)
                                                           \on-the-fly \mdashodd "—"
                                                           \italic \fromproperty #'header:nickname
                                                         }
      \on-the-fly #print-page-number-check-first \teeny \fromproperty #'page:page-number-string
    }
    \null
  }
  evenHeaderMarkup = \markup \column {
    \fill-line {
      \on-the-fly #print-page-number-check-first \teeny \fromproperty #'page:page-number-string
      \on-the-fly #not-part-first-page \normalsize \line { \fromproperty #'header:piece
                                                           \on-the-fly \mdasheven "—"
                                                           \italic \fromproperty #'header:variant
                                                         }
      \null
    }
    \null
  }
  oddFooterMarkup = \markup \null
}
